namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "endure")]
public class EndureEffect : Script, IScriptOnEndTurn, IScriptChangeIncomingDamage
{
    /// <inheritdoc />
    public void ChangeIncomingDamage(IPokemon pokemon, DamageSource source, ref uint damage)
    {
        if (damage > pokemon.CurrentHealth)
            damage = pokemon.CurrentHealth - 1;
    }

    /// <inheritdoc />
    public void OnEndTurn(IScriptSource owner, IBattle battle) => RemoveSelf();
}